diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java
index 159e90c92..5ba7fd264 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java
@@ -17,6 +17,7 @@ public class ChunkGeneratorNether
                 {
                     new CavesLargeFeature(64, 256),
                     new LavaFloeLargeFeature(),
+                    new RubyglassFloeLargeFeature(),
                     new ShelfLargeFeature()
                 }
         );
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
index e5b822b5a..095d6727c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
@@ -15,7 +15,7 @@ public class DensityGeneratorNether
     private final @NotNull Noise3D maxLimitNoise;
     private final @NotNull Noise3D mainNoise;
 
-    public DensityGeneratorNether(World world) {
+    public DensityGeneratorNether(@NotNull World world) {
         this.world = world;
 
         this.minLimitNoise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 0));
@@ -38,7 +38,10 @@ public class DensityGeneratorNether
         int quarterYSize = ((terrainHeight / 4) / 8) + 1;
         int threeQuarterYSize = ((int) (terrainHeight * 0.75f) / 8) + 1;
 
-        double[] densityMapArray = new double[xSize * ySize * zSize];
+        final int outerSize = xSize * ySize * zSize;
+
+        // Allocate a fresh array locally for thread safety
+        double[] densityMapArray = new double[outerSize];
         double[] biomeDensityMap = this.generateDensityMap(xSize, threeQuarterYSize, zSize, x, y, z);
 
         for (int dx = 0; dx < xSize; dx++) {
@@ -53,8 +56,13 @@ public class DensityGeneratorNether
         return densityMapArray;
     }
 
-    private double[] generateDensityMap(int xSize, int ySize, int zSize, int x, int y, int z) {
-        double[] densityMapArray = new double[xSize * ySize * zSize];
+    private double @NotNull[] generateDensityMap(int xSize, int ySize, int zSize, int x, int y, int z) {
+        final int innerSize = xSize * ySize * zSize;
+
+        double[] densityMapArray = new double[innerSize];
+        double[] mainNoiseArray = new double[innerSize];
+        double[] minLimitArray = new double[innerSize];
+        double[] maxLimitArray = new double[innerSize];
 
         final double mainNoiseScaleX = 80.0;
         final double mainNoiseScaleY = 60.0;
@@ -66,10 +74,12 @@ public class DensityGeneratorNether
         final double upperLimitScale = 512.0;
         final double lowerLimitScale = 512.0;
 
-        double[] mainNoiseArray = this.mainNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
-        double[] minLimitArray = this.minLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
-        double[] maxLimitArray = this.maxLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        this.mainNoise.getRegion(mainNoiseArray, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
+        this.minLimitNoise.getRegion(minLimitArray, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        this.maxLimitNoise.getRegion(maxLimitArray, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+
         int mainIndex = 0;
+
         double[] densityOffsetArray = new double[ySize];
         for (int dy = 0; dy < ySize; dy++) {
             densityOffsetArray[dy] = Math.cos(((double) dy * Math.PI * 6D) / (double) ySize) * 2D;
@@ -110,9 +120,7 @@ public class DensityGeneratorNether
                     densityMapArray[mainIndex] = density;
                     mainIndex++;
                 }
-
             }
-
         }
 
         return densityMapArray;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
index cc925031c..9f48d9c37 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
@@ -14,8 +14,7 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class SurfaceGeneratorNether
-    implements SurfaceGenerator {
+public class SurfaceGeneratorNether implements SurfaceGenerator {
     private final @NotNull World world;
 
     private final @NotNull FractalNoise3D<ImprovedPerlinNoise> beachNoise;
@@ -24,7 +23,22 @@ public class SurfaceGeneratorNether
 
     private final boolean generateStoneVariants = true;
 
+    // Cache common block IDs to avoid lookups
+    private final short soulSandId = (short) Blocks.SOULSAND.id();
+    private final short sulfurId = (short) Blocks.SULFUR.id();
+    private final short sulfurHardenedId = (short) Blocks.SULFUR_HARDENED.id();
+    private final short brimsandId = (short) Blocks.BRIMSAND.id();
+    private final short brimstoneId = (short) Blocks.BRIMSTONE.id();
+    private final short netherrackId = (short) Blocks.NETHERRACK.id();
+    private final short cobbleNetherrackId = (short) Blocks.COBBLE_NETHERRACK.id();
+    private final short cobbleNetherrackCrystallineId = (short) Blocks.COBBLE_NETHERRACK_CRYSTALLINE.id();
+    private final short cobbleGloomstoneId = (short) Blocks.COBBLE_GLOOMSTONE.id();
+    private final short glowstoneId = (short) Blocks.GLOWSTONE.id();
+    private final short ashId = (short) Blocks.BLOCK_ASH.id();
+    private final short slateId = (short) Blocks.SLATE.id();
+
     public SurfaceGeneratorNether(@NotNull World world) {
+        super();
         this.world = world;
 
         this.beachNoise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4, 40));
@@ -40,65 +54,70 @@ public class SurfaceGeneratorNether
         int chunkX = chunk.pos.x;
         int chunkZ = chunk.pos.z;
 
+        // Precompute
+        int absoluteOceanY = minY + oceanY;
+        int chunkWorldX = chunkX * Chunk.CHUNK_SIZE_X;
+        int chunkWorldZ = chunkZ * Chunk.CHUNK_SIZE_Z;
+
         int oceanBlock = this.world.getWorldType().getOceanBlockIds()[0];
         int worldFillBlock = this.world.getWorldType().getFillerBlockId();
 
         Random rand = new Random((long) chunkX * 0x4F9939F508L + (long) chunkZ * 0x1EF1565BD5L);
 
         double beachScale = 0.03125D;
-        double[] sandBeachNoise = this.beachNoise.getRegion(null, chunkX * 16, chunkZ * 16, 0.0D, 16, 16, 1, beachScale, beachScale, 1.0D);
-        double[] gravelBeachNoise = this.beachNoise.getRegion(null, chunkX * 16, 109.0134D, chunkZ * 16, 16, 1, 16, beachScale, 1.0D, beachScale);
-        double[] soilThicknessNoise = this.soilNoise.getRegion(null, chunkX * 16, chunkZ * 16, 0.0D, 16, 16, 1, beachScale * 2D, beachScale * 2D, beachScale * 2D);
+        double[] sandBeachNoise = this.beachNoise.getRegion(null, chunkWorldX, chunkWorldZ, 0.0D, 16, 16, 1, beachScale, beachScale, 1.0D);
+        double[] gravelBeachNoise = this.beachNoise.getRegion(null, chunkWorldX, 109.0134D, chunkWorldZ, 16, 1, 16, beachScale, 1.0D, beachScale);
+        double[] soilThicknessNoise = this.soilNoise.getRegion(null, chunkWorldX, chunkWorldZ, 0.0D, 16, 16, 1, beachScale * 2D, beachScale * 2D, beachScale * 2D);
 
-        double[] stoneLayerNoiseBasalt = null;
+/*        double[] stoneLayerNoiseBasalt = null;
         double[] stoneLayerNoiseNetherrack = null;
         double[] stoneLayerNoiseGloomstone = null;
         if (this.generateStoneVariants) {
             stoneLayerNoiseBasalt = this.soilNoise.getRegion(null, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z, 0.0D, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, 1, beachScale * 4D, beachScale * 4D, beachScale * 4D);
             stoneLayerNoiseNetherrack = this.mainNoise.getRegion(null, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z, 0.0D, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, 1, beachScale * 4D, beachScale * 4D, beachScale * 4D);
             stoneLayerNoiseGloomstone = this.beachNoise.getRegion(null, chunkX * Chunk.CHUNK_SIZE_X, chunkZ * Chunk.CHUNK_SIZE_Z, 0.0D, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, 1, beachScale * 4D, beachScale * 4D, beachScale * 4D);
-        }
+        }*/
+
         for (int z = 0; z < 16; z++) {
             for (int x = 0; x < 16; x++) {
-                boolean generateSoulSandBeach = sandBeachNoise[z + x * 16] + rand.nextDouble() * 0.2D > 0.0D;
-                boolean generateGravelBeach = gravelBeachNoise[z + x * 16] + rand.nextDouble() * 0.2D > 0.0D;
-                int soilThickness = (int) (soilThicknessNoise[z + x * 16] / 3D + 3D + rand.nextDouble() * 0.25D);
-
-                boolean generateBasaltLayer = false;
-                boolean generateNetherrackLayer = false;
-                boolean generateGloomstoneLayer = false;
-
-                int basaltThicknessLevel = 0;
-                int netherrackThicknessLevel = 0;
-                int gloomstoneThicknessLevel = 0;
-
-                if (this.generateStoneVariants) {
-                    generateBasaltLayer = stoneLayerNoiseBasalt[z + (x * Chunk.CHUNK_SIZE_Z)] + rand.nextDouble() * 0.2D > 0D;
-                    generateNetherrackLayer = stoneLayerNoiseNetherrack[z + (x * Chunk.CHUNK_SIZE_Z)] + rand.nextDouble() * 0.2D > 2D;
-                    generateGloomstoneLayer = stoneLayerNoiseGloomstone[z + (x * Chunk.CHUNK_SIZE_Z)] + rand.nextDouble() * 0.2D > 3D;
-                    basaltThicknessLevel = (int)(stoneLayerNoiseBasalt[z + x] + rand.nextDouble() * 0.5D);
-                    netherrackThicknessLevel = (int)(stoneLayerNoiseNetherrack[z + x] + rand.nextDouble() * 0.5D);
-                    gloomstoneThicknessLevel = (int)(stoneLayerNoiseGloomstone[z + x] + rand.nextDouble() * 0.5D);
-                }
+                int noiseIndex = z + x * 16;
+                boolean generateSoulSandBeach = sandBeachNoise[noiseIndex] + rand.nextDouble() * 0.2D > 0.0D;
+                boolean generateGravelBeach = gravelBeachNoise[noiseIndex] + rand.nextDouble() * 0.2D > 0.0D;
+                int soilThickness = (int) (soilThicknessNoise[noiseIndex] / 3D + 3D + rand.nextDouble() * 0.25D);
 
                 int currentLayerDepth = -1;
                 short topBlock = -1;
                 short fillerBlock = -1;
 
                 Biome lastBiome = null;
+                int worldX = chunkWorldX + x;
+                int worldZ = chunkWorldZ + z;
+
+                short cachedBiomeTopBlock = -1;
+                short cachedBiomeFillerBlock = -1;
+                boolean cachedBiomeGeneratesSulfur = false;
+                int cachedBiomeStoneBlockId = worldFillBlock;
 
                 for (int y = maxY; y >= minY; y--) {
                     Biome biome = chunk.getBlockBiome(x, y, z);
-                    if (biome == null)
-                        biome = this.world.getBiomeProvider().getBiome(chunkX * Chunk.CHUNK_SIZE_X + x, y >> 3, chunkZ * Chunk.CHUNK_SIZE_Z + z);
+                    if (biome == null) {
+                        biome = this.world.getBiomeProvider().getBiome(worldX, y >> 3, worldZ);
+                    }
+
+                    if (biome != lastBiome) {
+                        cachedBiomeTopBlock = (short) biome.getSurfaceProperties().getTopBlock().id();
+                        cachedBiomeFillerBlock = (short) biome.getSurfaceProperties().getFillerBlock().id();
+                        cachedBiomeGeneratesSulfur = biome.hasTag(BiomeTags.HAS_SULFUR_POOLS);
+                        cachedBiomeStoneBlockId = computeBiomeStoneBlock(biome, worldFillBlock);
+                        lastBiome = biome;
+                    }
 
                     int block = result.getBlock(x, y, z);
 
-                    if ((biome != lastBiome || topBlock == -1 || fillerBlock == -1) && block == 0) {
-                        topBlock = (short) biome.getSurfaceProperties().getTopBlock().id();
-                        fillerBlock = (short) biome.getSurfaceProperties().getFillerBlock().id();
+                    if ((topBlock == -1 || fillerBlock == -1) && block == 0) {
+                        topBlock = cachedBiomeTopBlock;
+                        fillerBlock = cachedBiomeFillerBlock;
                     }
-                    lastBiome = biome;
 
                     // reset the currently generating surface thickness to -1 if encountered air
                     if (block == 0) {
@@ -116,38 +135,36 @@ public class SurfaceGeneratorNether
                         // if soil thickness is below 0, generate a stone basin where there is no top block layer
                         if (soilThickness <= 0) {
                             topBlock = 0;
-                            fillerBlock = (short) Blocks.NETHERRACK.id();
+                            if (biome == Biomes.NETHER_VOLCANIC_ISLANDS) {
+                                fillerBlock = brimsandId;
+                            } else if (biome == Biomes.NETHER_SULFUR_POOLS) {
+                                fillerBlock = sulfurId;
+                            } else if (biome == Biomes.NETHER_OLD_WORLD || biome == Biomes.NETHER_OLD_WORLD_DESERT) {
+                                fillerBlock = cobbleGloomstoneId;
+                            } else {
+                                fillerBlock = netherrackId;
+                            }
                         } else {
-                            boolean biomeGeneratesSulfur = biome.hasTag(BiomeTags.HAS_SULFUR_POOLS);
-
-                            if (y >= minY + oceanY - 4 && y <= minY + oceanY + 1) {
-                                // Generate coastlines
-                                topBlock = (short) biome.getSurfaceProperties().getTopBlock().id();
-                                fillerBlock = (short) biome.getSurfaceProperties().getFillerBlock().id();
-                                if (generateGravelBeach) {
-                                    topBlock = (short) Blocks.GRAVEL.id();
-                                    fillerBlock = (short) Blocks.GRAVEL.id();
-                                } if (generateSoulSandBeach) {
-                                    topBlock = (short) Blocks.SOULSAND.id();
-                                    fillerBlock = (short) Blocks.SOULSAND.id();
-                                }
-                            } else if (y <= oceanY) {
-                                if (biomeGeneratesSulfur) {
-                                    topBlock = (short) Blocks.BRIMSAND.id();
-                                    fillerBlock = (short) Blocks.BRIMSAND.id();
+                            if (y >= absoluteOceanY - 4 && y <= absoluteOceanY + 1) {
+                                topBlock = cachedBiomeTopBlock;
+                                fillerBlock = cachedBiomeFillerBlock;
+                                if (generateGravelBeach || generateSoulSandBeach) {
+                                    topBlock = soulSandId;
+                                    fillerBlock = soulSandId;
                                 }
+                            } else if (y <= oceanY && cachedBiomeGeneratesSulfur) {
+                                topBlock = sulfurId;
+                                fillerBlock = sulfurHardenedId;
                             }
                         }
 
-                        // failsafe so that if a basin is generated under the ocean, the ocean is not replaced with air
-                        if (y < minY + oceanY && topBlock == 0) {
+                        if (y < absoluteOceanY && topBlock == 0) {
                             topBlock = (short) oceanBlock;
                         }
-                        // if a new surface layer has been chosen to be generated, set the current layer depth to the generated soil thickness level and begin generating downwards
-                        currentLayerDepth = soilThickness+2;
 
-                        // set block at index to designated surface block above ocean level
-                        if (y >= minY + oceanY - 1) {
+                        currentLayerDepth = soilThickness + 2;
+
+                        if (y >= absoluteOceanY - 1) {
                             result.setBlock(x, y, z, topBlock);
                         } else {
                             // if the block is below ocean level, set it to the chosen filler block
@@ -156,45 +173,40 @@ public class SurfaceGeneratorNether
                         continue;
                     }
 
-                    if (this.generateStoneVariants) {
-                        if (currentLayerDepth <= 0) {
-                            if (y >= (minY + basaltThicknessLevel - rand.nextInt(3)) && y <= (maxY - basaltThicknessLevel + rand.nextInt(3))) {
-                                if (generateBasaltLayer) {
-                                    result.setBlock(x, y, z, Blocks.COBBLE_BASALT.id());
-                                    continue;
-                                }
-                            }
-                            if (y >= (minY + netherrackThicknessLevel - rand.nextInt(3)) && y <= (maxY - netherrackThicknessLevel + rand.nextInt(3))) {
-                                if (generateNetherrackLayer) {
-                                    result.setBlock(x, y, z, Blocks.NETHERRACK.id());
-                                    continue;
-                                }
-                            }
-                            if (y >= (minY + gloomstoneThicknessLevel - rand.nextInt(3)) && y <= (maxY - gloomstoneThicknessLevel + rand.nextInt(3))) {
-                                if (generateGloomstoneLayer) {
-                                    result.setBlock(x, y, z, Blocks.COBBLE_GLOOMSTONE.id());
-                                    continue;
-                                }
-                            }
-                            continue;
-                        }
-                    }
-
-                    // fill blocks with filler block until current layer level = -1 or air is encountered
                     if (currentLayerDepth > 0) {
-                        currentLayerDepth--;
                         result.setBlock(x, y, z, fillerBlock);
+                        currentLayerDepth--;
+                    }
+
+                    if (currentLayerDepth == 0 && biome == Biomes.NETHER_OLD_WORLD && fillerBlock == ashId) {
+                        currentLayerDepth = rand.nextInt(8) + 2;
+                        fillerBlock = slateId;
                     }
 
-                    if(currentLayerDepth == 0)
-                    {
-                        if(biome.hasTag(BiomeTags.HAS_SULFUR_POOLS) && fillerBlock == Blocks.BRIMSAND.id()) {
-                            currentLayerDepth = rand.nextInt(4) + 2;
-                            fillerBlock = (short)Blocks.BRIMSAND.id();
+                    if (this.generateStoneVariants && currentLayerDepth <= 0) {
+                        int stoneBlockId = cachedBiomeStoneBlockId;
+                        // Crag/shelf is the only biome with a randomized variant per block.
+                        if (biome == Biomes.NETHER_CRAG || biome == Biomes.NETHER_SHELF) {
+                            stoneBlockId = (rand.nextInt(2) == 0) ? netherrackId : cobbleNetherrackId;
                         }
+                        result.setBlock(x, y, z, stoneBlockId);
                     }
                 }
             }
         }
     }
-}
+
+    private int computeBiomeStoneBlock(Biome biome, int worldFillBlock) {
+        if (biome == Biomes.NETHER_VOLCANIC_ISLANDS) {
+            return brimsandId;
+        } else if (biome == Biomes.NETHER_SULFUR_POOLS) {
+            return brimstoneId;
+        } else if (biome == Biomes.NETHER_CRYSTAL_PLAINS || biome == Biomes.NETHER_CRYSTAL_FOREST) {
+            return cobbleNetherrackId;
+        } else if (biome == Biomes.NETHER_OLD_WORLD || biome == Biomes.NETHER_OLD_WORLD_DESERT) {
+            return cobbleGloomstoneId;
+        }
+        // Crag/Shelf use a randomized choice per block, so callers handle them separately.
+        return worldFillBlock;
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
index 296323d8b..6c0280e47 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
@@ -1,100 +1,111 @@
 package net.minecraft.core.world.generate.chunk.perlin.nether;
 
-import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
-import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.biome.BiomeTags;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
-import net.minecraft.core.world.chunk.ChunkSection;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.TerrainGeneratorLerp;
-import net.minecraft.core.world.noise.FractalNoise3D;
-import net.minecraft.core.world.noise.ImprovedPerlinNoise;
-import net.minecraft.core.world.noise.Noise3D;
-import net.minecraft.core.world.type.WorldType;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 
-public class TerrainGeneratorNether
-    extends TerrainGeneratorLerp {
-    private final DensityGenerator densityGenerator;
+public class TerrainGeneratorNether extends TerrainGeneratorLerp {
+    private static final int OCEAN_FLUID_UNCACHED = -1;
 
-    private final int lastX = Integer.MIN_VALUE;
-    private final int lastZ = Integer.MIN_VALUE;
-    private @Nullable Biome lastBiome = null;
-    private final Object2IntMap<Biome> fluidLookup = new Object2IntArrayMap<>();
-//    private int lastChunkX = Integer.MIN_VALUE;
-//    private int lastChunkZ = Integer.MIN_VALUE;
-//    private final @NotNull Noise3D noise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(0L, 4, 0));
-//    private final double @NotNull [] cache = new double[Chunk.CHUNK_SIZE_X * Chunk.CHUNK_SIZE_Z * (Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y)];
+    private final DensityGenerator densityGenerator;
     private final int minY;
     private final int maxY;
+    private final int quarterHeight;
+    private final int bedrockId;
+    private final int airId;
+    private final int rubyglassId;
+    private final int waterId;
+    private final int oceanY;
+    private final int fillerBlockId;
+    private final int lavaId;
+    private final int cobbleNetherrackId;
+    private final int obsidianId;
+
+    private final ThreadLocal<int[]> oceanFluidByXZ = ThreadLocal.withInitial(() -> new int[256]);
+    private final ThreadLocal<Chunk> lastChunk = new ThreadLocal<>();;
 
     public TerrainGeneratorNether(@NotNull World world) {
         super(world);
 
         this.densityGenerator = new DensityGeneratorNether(world);
 
-        this.fluidLookup.put(Biomes.NETHER_VOLCANIC_ISLANDS, Blocks.FLUID_LAVA_STILL.id());
-        this.fluidLookup.put(Biomes.NETHER_SULFUR_POOLS, Blocks.FLUID_LAVA_STILL.id());
-        this.fluidLookup.put(Biomes.NETHER_CRAG, Blocks.FLUID_LAVA_STILL.id());
-        this.fluidLookup.put(Biomes.NETHER_SHELF, Blocks.COBBLE_NETHERRACK.id());
-        this.fluidLookup.put(Biomes.NETHER_CRYSTAL_FOREST, Blocks.FLUID_WATER_STILL.id());
-        this.fluidLookup.put(Biomes.NETHER_CRYSTAL_PLAINS, Blocks.FLUID_WATER_STILL.id());
-        this.fluidLookup.put(Biomes.NETHER_OLD_WORLD, Blocks.FLUID_WATER_STILL.id());
-        this.fluidLookup.put(Biomes.NETHER_OLD_WORLD_DESERT, Blocks.FLUID_WATER_STILL.id());
-
         this.minY = world.getWorldType().getMinY(world);
         this.maxY = world.getWorldType().getMaxY(world);
+        this.quarterHeight = this.maxY / 4;
+
+        // Cache block IDs to avoid repeated lookups to the Block objects themselves.
+        this.bedrockId = Blocks.BEDROCK.id();
+        this.airId = Blocks.AIR.id();
+        this.rubyglassId = Blocks.RUBYGLASS_CRYSTAL.id();
+        this.waterId = Blocks.FLUID_WATER_STILL.id();
+        this.lavaId = Blocks.FLUID_LAVA_STILL.id();
+        this.cobbleNetherrackId = Blocks.COBBLE_NETHERRACK.id();
+        this.obsidianId = Blocks.OBSIDIAN.id();
 
+        this.oceanY = world.getWorldType().getOceanY();
+        this.fillerBlockId = world.getWorldType().getFillerBlockId();
     }
 
-    @Override
-    protected int getBlockAt(@NotNull Chunk chunk, int x, int y, int z, double density) {
-        if (this.lastX != x || this.lastZ != z) {
-            this.lastBiome = chunk.getBlockBiome(x, 0, z);
+    private int getFluidForBiome(Biome biome) {
+        if (biome == Biomes.NETHER_VOLCANIC_ISLANDS || biome == Biomes.NETHER_SULFUR_POOLS || biome == Biomes.NETHER_CRAG) {
+            return this.lavaId;
+        } else if (biome == Biomes.NETHER_CRYSTAL_FOREST || biome == Biomes.NETHER_CRYSTAL_PLAINS) {
+            return this.waterId;
+        } else if (biome == Biomes.NETHER_SHELF) {
+            return this.cobbleNetherrackId;
+        } else if (biome == Biomes.NETHER_OLD_WORLD) {
+            return this.obsidianId;
         }
+        return 0;
+    }
 
-        WorldType type = this.world.getWorldType();
-        int quarterHeight = maxY / 4;
+    private int getCachedOceanFluid(@NotNull Chunk chunk, int x, int z) {
+        int[] cache = this.oceanFluidByXZ.get();
 
-        if (y < quarterHeight) {
-            return 0;
-        } else if (y >= maxY - this.rand.nextInt(5)) {
-            return Blocks.BEDROCK.id();
-        } else if (y <= quarterHeight + this.rand.nextInt(5)) {
-            return Blocks.BEDROCK.id();
-        } else if (density > 0.0) {
-//            Disabled crystalline netherrack veins
-//            if (this.lastBiome != null && this.lastBiome.hasTag(BiomeTags.HAS_CRYSTAL_VEINS)) {
-//                int sizeY = Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
-//
-//                if (this.lastChunkX != chunk.pos.x || this.lastChunkZ != chunk.pos.z) {
-//                    this.lastChunkX = chunk.pos.x;
-//                    this.lastChunkZ = chunk.pos.z;
-//                    this.noise.getRegion(this.cache, chunk.pos.x * Chunk.CHUNK_SIZE_X, 0, chunk.pos.z * Chunk.CHUNK_SIZE_Z, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, 0.2, 0.2, 0.2);
-//                }
-//
-//                // YZX ordering
-//                final double d = ((this.cache[(x * Chunk.CHUNK_SIZE_Z * sizeY) + (z * sizeY) + y]));
-//                if (d > -1 && d < 2) {
-//                    return Blocks.COBBLE_NETHERRACK_CRYSTALLINE.id();
-//                }
-//            }
-
-            return type.getFillerBlockId();
-        } else if (y < type.getOceanY()) {
-            return this.fluidLookup.getOrDefault(this.lastBiome, 0);
+        if (chunk != this.lastChunk.get()) {
+            java.util.Arrays.fill(cache, OCEAN_FLUID_UNCACHED);
+            this.lastChunk.set(chunk);
         }
 
-        return 0;
+        final int idx = (x << 4) | z;
+        int cached = cache[idx];
+        if (cached == OCEAN_FLUID_UNCACHED) {
+            cached = this.getFluidForBiome(chunk.getBlockBiome(x, this.oceanY, z));
+            cache[idx] = cached;
+        }
+        return cached;
+    }
+
+    @Override
+    protected int getBlockAt(@NotNull Chunk chunk, int x, int y, int z, double density) {
+        if (y < this.quarterHeight) {
+            return this.bedrockId;
+        } else if (y >= this.maxY - this.rand.nextInt(10)) {
+            return this.bedrockId;
+        } else if (y <= this.quarterHeight + this.rand.nextInt(10)) {
+            return this.bedrockId;
+        } else if (density > 0.0) {
+            return this.fillerBlockId;
+        } else if (y < this.oceanY) {
+            final int fluidId = this.getCachedOceanFluid(chunk, x, z);
+
+            if (fluidId == this.waterId && y == this.oceanY - 1) {
+                return this.rubyglassId;
+            }
+
+            return fluidId;
+        } else {
+            return this.airId;
+        }
     }
 
     @Override
     public @NotNull DensityGenerator getDensityGenerator() {
         return this.densityGenerator;
     }
-}
+}
\ No newline at end of file
